/*->c.syncdiscs */


#include <stdafx.h>


#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "flex.h"


#include "err.h"
#include "alloc.h"
#include "fsx.h"
#include "etc.h"
#include "bf.h"
#include "bits.h"
#include "timex.h"
#include "deb.h"
#include "scrap.h"
#include "wos.h"


#include "constants.h"

#include "reslink.h"


#include "arcs.h"
#include "opendir.h"
#include "zstring.h"
#include "zone.h"
#include "dbox.h"

#include "syncdiscs.h"



//#define INACTIVE

#define TEXTF 0xFFF


static char     oldpath[NAMELEN];
static char     newpath[NAMELEN];
static char     scrappath[NAMELEN];

static buffer * bfp;
static char     logpath[NAMELEN];


static int      newer;
static int      extra;
static int      doscrap;
static int      overwrite;
static int      compare;
static int      comparex=0;
static int      timeresolution;

static buffer * cfp;
static int      csh;




static os_error * comparewrite(char * format,...)
{
 os_error * err;
 va_list    args;
 char       v[NAMELEN];

 va_start(args, format);
 vsprintf(v, format, args);

 va_end(args);

 err=bf_printf(cfp,v);

 return(err);
}




static os_error * comparewritef(int acn,int n,char * format)
{
 os_error * err;
 char       s[NAMELEN];

 s[0]=0;

 filepath1(s,acn,n);

 err=bf_printf(cfp,format,s);

 return(err);
}




static os_error * comparewriteft(int acn,int n,heads * hdr,int j,char * format)
{
 os_error * err;
 char       s[NAMELEN];
 char       timeformat[128];
 arctime    tx;
 char       t1[128];
 char       t2[128];

 s[0]=0;

 filepath1(s,acn,n);

 getsysdate(timeformat,1,1);


 tx.lo=hdr[j].exec;
 tx.hi=hdr[j].load & 0xFF;
 writets(t1,timeformat,(arctime*)&tx);

 tx.lo=arc[acn].hdr[n].exec;
 tx.hi=arc[acn].hdr[n].load & 0xFF;
 writets(t2,timeformat,(arctime*)&tx);

 err=bf_printf(cfp,format,s,t1,t2);

 return(err);
}


static os_error * comparewritefl(int acn,int n,heads * hdr,int j,char * format)
{
 os_error * err;
 char       s[NAMELEN];
 char       t1[128];
 char       t2[128];

 s[0]=0;

 filepath1(s,acn,n);

 sprintf(t1,"%d",hdr[j].length);
 sprintf(t2,"%d",arc[acn].hdr[n].length);
 err=bf_printf(cfp,format,s,t1,t2);

 return(err);
}




/**********************************************************************************************/


static os_error * copyobjects(char * from,char * to,int flags,char * spare1,char * spare2)
{
 os_error   * err;
 fxstat       f;
 fsscanhandle savescan;
 int          eof;
 char       * fs;
 char       * ts;

 err=NULL;

 fs_stat(from,&f.f);

 if(f.f.object==2)
 {
  fs_stat(to,&f.f);
  if(f.f.object==0) err=fs_cdir(to);
  if(!err)
  {
   fs_savescan(&savescan);
   fs_startscan();
   while(1)
   {
    err=fs_nextitem(from,&f,"*.*",&eof);
    if(err) break;
    if(eof) break;

    fs=from+strlen(from);
    ts=to+strlen(to);
    strcpy(fs,"\\");
    strcpy(fs+1,f.name);
    strcpy(ts,"\\");
    strcpy(ts+1,f.name);

    err=copyobjects(from,to,flags,spare1,spare2);
    if(err) break;

    *fs=0;
    *ts=0;
   }
   fs_endscan();
   fs_loadscan(savescan);
   if(!err)
   {
    if(flags & FS_MOVE) err=fs_delete(from);
   }
  }
 }
 else
 if(f.f.object==1)
 {
  err=fs_copyfile(from,to);
  if(!err)
  {
/*

Primary newer - Install\deb.h    [2:11AM 31 Mar 02] [1:11AM 31 Mar 02]
Primary newer - Uninstall\deb.h    [2:11AM 31 Mar 02] [1:11AM 31 Mar 02]

Seemingly stamping a file need not change the timestamp. The above is the result
after a copy. Even copying by hand gives the same result. Destination DVD RAM

			fstat f1;
			fs_stat(to,&f1);
			cprintf("fs1 %x %x",f1.load,f1.exec);
			cprintf("fsp %x %x",f.f.load,f.f.exec);
			fs_stamp(to,&f.f);
   fs_stat(to,&f1);
			cprintf("fs2 %x %x",f1.load,f1.exec);
*/
   if(flags & FS_MOVE) err=fs_delete(from);
  }
 }

 return(err);
}



static os_error * copyobject(char * from,char * to,int flags,char * spare1,char * spare2)
{
 os_error * err;
 char ft[MAX_PATH];
 char tt[MAX_PATH];

 if(flags & FS_MOVE)
 {
  err=fs_rename(from,to);
  if(!err) return(err);
 }

 strcpy(ft,from);
 strcpy(tt,to);

 return(copyobjects(ft,tt,flags,spare1,spare2));
}




static os_error * filecopy(char * from,char * to,int move)
{
 os_error * err;

 err=NULL;

 if(cstrcmp(logpath,from))
 {
  err=fs_validatepath(to,0);

//  cprintf("copyobject in");

#ifndef INACTIVE
  if(!err) err=copyobject(from,to,move?FS_MOVE:0,NULL,NULL);
#endif
//  cprintf("copyobject out");
 }

 return(err);
}




static os_error * getnewdir(int acn,int dir,heads ** hdr,int * size)
{
 os_error * err;

 arc[acn].path=newpath;
 err=opengetdir(acn,dir,hdr,size);
 arc[acn].path=oldpath;

 return(err);
}


                                       

static os_error * newcopy(int acn,int n,int update)
{
 os_error * err;
 char       subpath[NAMELEN];
 char       source[NAMELEN];
 char       dest[NAMELEN];


 err=NULL;

 subpath[0]=0;
 filepath1(subpath,acn,n);

 if(doscrap && update)
 {
  fs_join(source,NITEM(source),oldpath,subpath);
  fs_join(dest,NITEM(dest),scrappath,subpath);
//  sprintf(source,"%s\\%s",oldpath,subpath);
//  sprintf(dest,"%s\\%s",scrappath,subpath);

  if(bfp) err=bf_printf(bfp,"move:%s to %s\r\n",source,dest);

  if(!err) err=filecopy(source,dest,1);
 }

 fs_join(source,NITEM(source),newpath,subpath);
 fs_join(dest,NITEM(dest),oldpath,subpath);
// sprintf(source,"%s\\%s",newpath,subpath);
// sprintf(dest,"%s\\%s",oldpath,subpath);

 err=progressupdate(source);
 if(!err)
 {
  if(bfp) err=bf_printf(bfp,"copy:%s to %s\r\n",source,dest);
  if(!err) err=filecopy(source,dest,0);
 }

 return(err);
}






static os_error * newreversecopy(int acn,int n,int update)
{
 os_error * err;
 char       subpath[NAMELEN];
 char       source[NAMELEN];
 char       dest[NAMELEN];


 err=NULL;

 subpath[0]=0;
 filepath1(subpath,acn,n);

 if(doscrap && update)
 {
  fs_join(source,NITEM(source),newpath,subpath);
  fs_join(dest,NITEM(dest),scrappath,subpath);
//  sprintf(source,"%s\\%s",newpath,subpath);
//  sprintf(dest,"%s\\%s",scrappath,subpath);

  if(bfp) err=bf_printf(bfp,"move:%s to %s\r\n",source,dest);

  if(!err) err=filecopy(source,dest,1);
 }

 fs_join(source,NITEM(source),oldpath,subpath);
 fs_join(dest,NITEM(dest),newpath,subpath);
// sprintf(source,"%s\\%s",oldpath,subpath);
// sprintf(dest,"%s\\%s",newpath,subpath);

 err=progressupdate(source);
 if(!err)
 {
  if(bfp) err=bf_printf(bfp,"copy:%s to %s\r\n",source,dest);

  if(!err) err=filecopy(source,dest,0);
 }

 return(err);
}




static os_error * newremove(int acn,int n)
{
 os_error * err;
 char       path[NAMELEN];
 char       source[NAMELEN];
 char       dest[NAMELEN];


 err=NULL;


// cprintf("******************************newremove\n\n");

 path[0]=0;
 filepath1(path,acn,n);

// sprintf(source,"%s\\%s",oldpath,path);

 fs_join(source,NITEM(source),oldpath,path);

 err=progressupdate(source);
 if(!err)
 {
  if(doscrap)
  {
//   sprintf(dest,"%s\\%s",scrappath,path);
   fs_join(dest,NITEM(dest),scrappath,path);

   if(bfp) err=bf_printf(bfp,"move:%s to %s\r\n",source,dest);

//   cprintf("copy %s %s",source,dest);
   err=filecopy(source,dest,1);
  }
  else
  {
   if(bfp) err=bf_printf(bfp,"remove:%s\r\n",source);

//   cprintf("wipe %s",source);
#ifndef INACTIVE
   err=fs_wipe(source);
#endif
  }
 }

 return(err); 
}



static int ignorefile(int acn,int dir,char * leaf)
{
 char path[NAMELEN];
 int  inz;

 strcpy(path,newpath);
 if(dir>=0) filepath1(path,acn,dir);
 fs_strcat(path,NITEM(path),leaf);

 inz=inzone(path,NULL);

 if(bfp && inz) bf_printf(bfp,"ignore:%s\r\n",path);

 return(inz);
}





static void	comparexcode(int difftime,int difflen,int acn,int n,heads * hdr,int j)
{
	os_error * err;
	char s1[NAMELEN];
	char s2[NAMELEN];
	unsigned char * base1;
	unsigned int length1;
	unsigned char * base2;
	unsigned int length2;
	unsigned char * p1;
	unsigned char * p2;
	unsigned char * lt1;


	strcpy(s1,newpath);
	strcpy(s2,oldpath);
 filepath1(s1,acn,n);
 filepath1(s2,acn,n);


//	cprintf("check %s %s",s1,s2);


//	if(difflen) cprintf("difflen %d %s",difflen,hdr[j].length,arc[acn].hdr[n].length,s1);

	if(difflen!=0 && 0)
 {
  if(difftime==0) comparewritefl(acn,n,hdr,j,"Lengths differ times the same!!!- %s    [%s] [%s]\r\n");
		else
  if(difftime>0) comparewriteft(acn,n,hdr,j,"Primary older - %s    [%s] [%s]\r\n");
  else
  if(difftime<0) comparewriteft(acn,n,hdr,j,"Primary newer - %s    [%s] [%s]\r\n");
	}

	if(1) //!difflen || 1)
	{
		err=fs_alloc(s1,&base1,&length1);
		if(!err)
		{
   err=fs_alloc(s2,&base2,&length2);
			if(!err)
			{
//				if(length1==length2)
				{
					p1=base1;
					p2=base2;
					lt1=p1+length1;

//					cprintf("check 1 p1 %x lt1 %x",p1,lt1);

					while(p1<lt1)
					{
						if(*p1++!=*p2++)
						{
//						 cprintf("*** diffbytes %s",s1);
//       comparewriteft(acn,n,hdr,j,"Different contents - %s    [%s] [%s]\r\n");
       if(difftime>0) comparewriteft(acn,n,hdr,j,"Primary older contents differ - %s    [%s] [%s]\r\n");
       else
       if(difftime<0) comparewriteft(acn,n,hdr,j,"Primary newer contents differ - %s    [%s] [%s]\r\n");
							else											comparewritefl(acn,n,hdr,j,"Contents differ times the same!!!- %s    [%s] [%s]\r\n");


							break;
						}
					}
//					cprintf("check 1 p1 %x lt1 %x",p1,lt1);

				}
//				else
				{
//					cprintf("lenghts differ");

				}


				sfree((flex_ptr)&base2);
			}
			sfree((flex_ptr)&base1);
		}

		if(err) cprintf("error %s",err->errmess);
	}

}





/* we have an old structure acn,dir, i and a new one hdr, j */
/* make the old one into the new one              */


static os_error * syncdir(int acn,int dir)
{
 os_error        * err;
 heads           * hdr=NULL;
 int               size=0;
 int               i;
 int               j;
 int               n;
 int               code;
 int               incn;
	int               ignoreprimary;
 int               dsize;
 int               name;
 int               difflen;
 _int64            difftime;
 _int64            t1;
 _int64            t2;

 err=NULL;

 if(dir>=0 && arc[acn].hdr[dir].dirn==DFLAT) err=opendir(acn,dir);

 if(err) cprintf("opendir err");

 if(!err) err=getnewdir(acn,dir,&hdr,&size);

 if(err) cprintf("getnewdir err");

 if(!err)
 {
  j=0;
  n=dir+1;

  for(i=0;i<((dir<0)?arc[acn].fmain:arc[acn].hdr[dir].dirn);i++)
  {
   incn=1;

   ignoreprimary=(j<size && ignorefile(acn,dir,zstringptr(hdr[j].name)));
/* while(ignoreprimary)  {
    j++;
   }
*/

//   cprintf("j=%d size=%d",j,size);

   if(j<size)
   {
    code=cstrcmp(zstringptr(arc[acn].hdr[n].name),zstringptr(hdr[j].name));
//    cprintf("cmp %s %s",zstringptr(arc[acn].hdr[n].name),zstringptr(hdr[j].name));
   }
   else
    code=-1;

   if(code==0) /* same names - check time stamps */
   {
				if(ignoreprimary)
				{
					// do nothing

				}
				else
    if(arc[acn].hdr[n].dirn==DNFILE && hdr[j].dirn==DNFILE)
    {
     difflen=arc[acn].hdr[n].length-hdr[j].length;
     t1=(((_int64)(arc[acn].hdr[n].load & 0xFF))<<32)|(((_int64)arc[acn].hdr[n].exec) & 0xFFFFFFFF);
     t2=(((_int64)(hdr[j].load & 0xFF))<<32)|(((_int64)hdr[j].exec) & 0xFFFFFFFF);
     difftime=t1-t2;

//     cprintf("load1 %x exec1 %x",arc[acn].hdr[n].load,arc[acn].hdr[n].exec);
//     cprintf("t1 %x t1 %x",(int)t1,(int)(t1>>32));
//     cprintf("t2 %x t2 %x",(int)t2,(int)(t2>>32));
//     cprintf("%s difftime %d",zstringptr(arc[acn].hdr[n].name),(int)difftime);

     if(difftime<(_int64)timeresolution && difftime>0) difftime=0;
     if(difftime>-(_int64)timeresolution && difftime<0) difftime=0;

/*
     code=(arc[acn].hdr[n].load & 0xFF)-(hdr[j].load & 0xFF);
     if(code==0)
     {
      code=((unsigned int)arc[acn].hdr[n].exec)>
                               ((unsigned int)hdr[j].exec);
      if(code==0) code=-(((unsigned int)arc[acn].hdr[n].exec)<
                               ((unsigned int)hdr[j].exec));
     }
*/

//     if(difftime) cprintf("difftime %x %x over %x",(int)difftime,(int)(difftime>>32),overwrite);

     if(compare)
     {
				 	if(comparex)
						{
							comparexcode(difftime,difflen,acn,n,hdr,j);
						}
						else
						{
       if(difftime>0) comparewriteft(acn,n,hdr,j,"Primary older - %s    [%s] [%s]\r\n");
       else
       if(difftime<0) comparewriteft(acn,n,hdr,j,"Primary newer - %s    [%s] [%s]\r\n");
						 else
       if(difflen)    comparewritefl(acn,n,hdr,j,"Lengths differ - %s    [%s] [%s]\r\n");
						}
     }
     else
     {
      if(difftime>0 && !overwrite) /* client is newer than server */
      {
       /* reverse update */
       //cprintf("reverse update");

       if(newer)
       {
        err=newreversecopy(acn,n,1);
        //       if(err) cprintf("newreversecopy returns error");
       }
      }
      else
      if(difftime<0 || (difftime>0 && overwrite) || difflen) /* client older than server or different */
      {

       //cprintf("update file");
       /* update file */
       //      cprintf("update file");
       name=arc[acn].hdr[n].name;
       arc[acn].hdr[n]=hdr[j];
       arc[acn].hdr[n].name=name;
       arc[acn].hdr[n].get=1;
       arc[acn].hdr[n].update=1;
      }
      else
      {
       /* client and server same times */
      }
     }
    }
    else  /* types clash */
    if((arc[acn].hdr[n].dirn==DNFILE && hdr[j].dirn!=DNFILE) ||
       (arc[acn].hdr[n].dirn!=DNFILE && hdr[j].dirn==DNFILE))
    {
     if(!compare) err=newremove(acn,n);
     //     if(err) cprintf("new remove2 returns error");
     if(!err)
     {
      name=arc[acn].hdr[n].name;
      arc[acn].hdr[n]=hdr[j];
      arc[acn].hdr[n].name=name;
      arc[acn].hdr[n].get=1;
      arc[acn].hdr[n].update=0;
      if(arc[acn].hdr[n].dirn!=DNFILE) arc[acn].hdr[n].dirn=0;
      if(compare)
      {
       comparewritef(acn,n,"File/Directory same name - %s\r\n");
      }
     }
    }

    j++;
   }
   else if(code>0)
   {
				if(!ignoreprimary)
				{
     err=insentry(acn,n,dir,1);
//    if(err) cprintf("insentry returns error");
     if(err) break;
     arc[acn].hdr[n]=hdr[j];
     zdupstring(hdr[j].name,&name);
     arc[acn].hdr[n].name=name;
     arc[acn].hdr[n].get=1;
     arc[acn].hdr[n].update=0;
     if(arc[acn].hdr[n].dirn!=DNFILE) arc[acn].hdr[n].dirn=0;

     if(compare)
     {
      comparewritef(acn,n,"Extra on primary - %s\r\n");
     }
				 j++;
				}
				else
				{
					j++;
					i--;
					incn=0;
				}
   }
   else  /* local entry which is not on server */
   {
				if(ignoreprimary)
				{
					i--;
					incn=0;
					j++;
				}
				else
    if(compare)
    {
     comparewritef(acn,n,"Extra on secondary - %s\r\n");

     if(arc[acn].hdr[n].dirn>=0) dsize=noindir(acn,n)+1;
     else                        dsize=1;
     scrapentry(acn,n,dsize);
     rementry(&arc[acn],n,dsize);
     i--;
     incn=0;
    }
    else
    {
     if(extra)
     {
      err=newreversecopy(acn,n,0);
      //if(err) cprintf("new rev copy returns error");
      if(err) break;
     }
     else
     {
      err=newremove(acn,n);
      //if(err) cprintf("new remove1 returns error");
      if(err) break;

      if(arc[acn].hdr[n].dirn>=0) dsize=noindir(acn,n)+1;
      else                        dsize=1;

//      cprintf("newremove dsize %d %s",dsize,zstringptr(arc[acn].hdr[n].name));
     
      scrapentry(acn,n,dsize);
      rementry(&arc[acn],n,dsize);
      i--;
      incn=0;
     }
    }
   }

   if(err) break;

   if(incn)
   {
    if(arc[acn].hdr[n].dirn>=0) n+=noindir(acn,n)+1;
    else                        n++;
   }
  }

  if(!err)
  {
   while(j<size)
   {
    if(ignorefile(acn,dir,zstringptr(hdr[j].name)))
    {
     j++;
    }
    else
    {
     /* fetch entry from server */
     err=zdupstring(hdr[j].name,&name);
     if(err) break;
//if(err) cprintf("zdup err");
     err=insentry(acn,n,dir,1);
//if(err) cprintf("insentry returns error");
     if(err) break;
     arc[acn].hdr[n]=hdr[j];
     arc[acn].hdr[n].name=name;
     arc[acn].hdr[n].get=1;
     arc[acn].hdr[n].update=0;
     if(arc[acn].hdr[n].dirn!=DNFILE) arc[acn].hdr[n].dirn=0;
     if(compare)
     {
      comparewritef(acn,n,"Extra on primary - %s\r\n");
     }
     n++;
     j++;
    }
   }
  }

  if(!err)
  {
   n=dir+1;

   for(i=0;i<((dir<0)?arc[acn].fmain:arc[acn].hdr[dir].dirn);i++)
   {
    if(!compare && arc[acn].hdr[n].get)
    {
     err=newcopy(acn,n,arc[acn].hdr[n].update);
//     if(err) cprintf("newcopy returns error");
     if(err) break;
    }

    if(arc[acn].hdr[n].dirn>=0) n+=noindir(acn,n)+1;
    else                        n++;
   }
  }
 }




 if(hdr)
 {
  for(i=0;i<size;i++)
  {
   zrmstring(hdr[i].name);
  }
  flex_free((flex_ptr)&hdr);
 }



// cprintf("ex syncdir");

 return(err);
}







static os_error * updatedir(int acn,int dir)
{
 os_error        * err;
 int               i;
 int               level;
 int               ln;
 int               in;
 int               pn;
 int               n;
 int               size;


// cprintf("updatedir ");

//   cprintf("0 hdr %x",arc[acn].hdr);


 for(i=0;i<arc[acn].nofiles;i++)
 {
  arc[acn].hdr[i].get=arc[acn].hdr[i].put=0;
 }

 err=syncdir(acn,dir);
// if(err) cprintf("syncdir returns error");

//   cprintf("1 hdr %x",arc[acn].hdr);

 if(!err)
 {
  level=1;
  in=0;
  if(dir<0) ln=arc[acn].fmain;
  else      ln=arc[acn].hdr[dir].dirn;
  pn=dir;
  n=dir+1;

  while(level>0)
  {
   for(i=in;i<ln;i++)
   {
    if(arc[acn].hdr[n].dirn>=0 || arc[acn].hdr[n].dirn==DFLAT)
    {
     if(!arc[acn].hdr[n].get)
     {
      err=syncdir(acn,n);
      if(err) break;

      posn2[level]=pn;
      lno2[level]=ln;
      fpos2[level]=i;
      pn=n;
      i=0;
      in=0;
      ln=arc[acn].hdr[n].dirn+1;
      levelstackcheck(++level);
     }
    }
    n++;
   }

   if(err) break;

   /* can close dir at pn now */

//   cprintf("hdr %x",arc[acn].hdr);

   closedir(acn,pn,&size);
   n-=size;

   level--;

   if(level)
   {
    pn=posn2[level];
    ln=lno2[level];
    in=fpos2[level]+1;
   }
  }
 }

 return(err);
}



static os_error * checknewpath(void)
{
 os_error * err;
 fxstat     f;
 int        eof;

 fs_startscan();
 err=fs_nextitem(newpath,&f,"*.*",&eof);
 fs_endscan();

 if(!err)
 {
  if(eof) err=geterror(EEMPTY);
 }

 return(err);
}




os_error * syncdiscs(char * primary,char * secondary,char * scrap,
                                    char * logfile,int xflags,int timeres)
{
 os_error * err;
 int        oldarcn;
 buffer     bf;
 buffer     cbf;
 fstat      f;
 char     * p;
 int        c;


 err=NULL;


 if(logfile) fs_canonicalpath(logfile,logpath,sizeof(logpath),NULL,NULL);


 newer=xflags & 0x1;
 extra=(xflags>>1) & 0x1;
 overwrite=(xflags>>2) & 0x1;
 compare=(xflags>>3) & 0x1;
 timeresolution=timeres;

 if(compare)
 {
  char string[NAMELEN];

  if(!csh) sc_create(&csh);
  cfp=&cbf;
  sprintf(string,"%s.txt",sc_name(csh));
  err=bf_open(string,'w',DEFBUFFSIZE,&cbf);
  if(!err)
  {
   writesystimedate(string);
 
   comparewrite("Compare at %s\r\n",string);
  }
  else
  {
   cfp=NULL;
  }
 }

 if(!err)
 {
  while(1)
  {
   p=oldpath;
   while(1)
   {
    c=*secondary;
    if(!c) break;
    secondary++;
    if(c=='|') break;
    //  if(c!=' ') 
    *p++=(char)c;
   }
   *p=0;


   p=newpath;
   while(1)
   {
    c=*primary;
    if(!c) break;
    primary++;
    if(c=='|') break;
    //   if(c!=' ')
    *p++=(char)c;
   }
   *p=0;


   p=scrappath;
   while(1)
   {
    c=*scrap;
    if(!c) break;
    scrap++;
    if(c=='|') break;
    //   if(c!=' ') 
    *p++=(char)c;
   }
   *p=0;


   if(!oldpath[0] && !newpath[0]) break;
   else
   if(!oldpath[0]) 
         err=generror(0,"Primary path has fewer entries than secondary");
   else
   if(!newpath[0])
         err=generror(0,"Secondary path has fewer entries than primary");

   if(err) break;


   doscrap=strlen(scrappath);

   if(compare)
   {
    comparewrite("Primary %s\r\n",newpath);
    comparewrite("Secondary %s\r\n\r\n",oldpath);
   }

   if(logfile)
   {
    fs_stat(logfile,&f);

    bfp=&bf;
    err=bf_open(logfile,'u',DEFBUFFSIZE,&bf);
    if(!err)
    {
     char string[NAMELEN];

     if(f.object) err=bf_seek(bfp,f.length);

     writesystimedate(string);
 
     bf_printf(bfp,"SyncDiscs at %s\r\n",string);
     bf_printf(bfp,"Primary %s\r\n",newpath);
     bf_printf(bfp,"Secondary %s\r\n",oldpath);
     if(doscrap) bf_printf(bfp,"Scrap %s\r\n",scrappath);
     bf_printf(bfp,"\r\n\r\n");
    }
    else
    {
     bfp=NULL;
    }
   }
   else
   {
    bfp=NULL;
   }


   if(!err) err=fs_validatepath(oldpath,1);

   if(!err) err=checknewpath();

   if(!err)
   {
//    cprintf("loaddir");
   
    err=loaddir(oldpath,&oldarcn);
    //   cprintf("arcn %d",oldarcn);
    if(!err)
    {
     err=updatedir(oldarcn,-1);
    }

    if(oldarcn>=0) losearc(oldarcn);
   }

   if(bfp)
   {
    bf_printf(bfp,"\r\n\r\n");
    err=bf_closec(bfp,err,logfile,0);
   }

   if(err) break;
  }

  if(compare && cfp)
  {
   char temp[NAMELEN];

   err=bf_closec(cfp,err,sc_name(csh),TEXTF);
   sprintf(temp,"%s.txt",sc_name(csh));
   oscommand(syncdiscshandle,"open",temp,NULL,NULL,0);
  }
 }
 return(err);
}

