/*->c.main */

#include <stdafx.h>
#include "resource.h"


#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimpt.h"
#include "werr.h"

#include "err.h"
#include "wos.h"
#include "temp.h"
#include "task.h"
#include "flex.h"
#include "poll.h"
#include "etc.h"
#include "scrap.h"
#include "deb.h"
#include "fsx.h"
#include "mlo.h"
#include "pane.h"
#include "appinfo.h"
//#include "getdir.h"
#include "osshell.h"
#include "oshelp.h"

#include "constants.h"

#include "reslink.h"

#include "arcs.h"

#include "zone.h"

#include "dbox.h"


#include "main.h"




int    version=109;
int    compatability=0;
char * datestring="(08-March-2003)";





void terminate(void)
{
 event(EVENT_ENDPROGRAM,NULL,0);
 scrapfinit();
 osshellfinit(0);
 report(finittask());
}




static os_error * terminatemessage(wimp_msgstr * msg,int * ack)
{
 terminate();
 USE(msg);
 USE(ack);
 return(NULL);
}




static os_error * addmessages(void)
{
 os_error * err;

 err=addmessage(terminatemessage,wimp_MCLOSEDOWN);

 return(err);
}





os_error * helpdecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 cprintf("mindo  %d",menu[0]);

 switch(menu[0])
 {
  case ID_HELP_ABOUT:
         err=infowindow(syncdiscshandle,version,datestring);
         break;

  case ID_HELP_HELPTOPICS:
         err=helptopic(window,"<HKEY_LOCAL_MACHINE\\Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\SyncDiscs.exe\\Path>\\SyncDiscs.chm>");
         break;
 }

 return(err);

 USE(window);
}



os_error * workdecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {
 case ID_WORKSPACE_NEWWORKSPACE:
                                err=opennew(window);
                                break;


 }

 
 USE(window);


 return(err);
}




os_error * filedecode(int * menu,int window)
{
 os_error * err;



 switch(menu[0])
 {
  case ID_FILE_SYNCHRONISE:
                                    err=configsave();
                           if(!err) err=syncdiscsdb();
                           break;

      case ID_FILE_COMPARE:
                                    err=configsave();
                           if(!err) err=dbcompare();
                           break;

         case ID_FILE_EXIT:
                           err=syncdiscsclose(window,0);
                           break;
 }


 return(NULL);

 USE(window);
}




os_error * configdecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 switch(menu[0])
 {
  case ID_CONFIGURE_OPTIONS:
                            err=openoptions(window);
                            break;


  case ID_CONFIGURE_LOGGING:
                            err=openlog(window);
                            break;
 }
 
 return(err);
}


os_error * maindynamic(int * menu,char * handle,int window)
{

 USE(menu);
 USE(handle);
 USE(window);

 return(NULL);
}




os_error * maindecode(int * menu,int window)
{
 os_error * err;

 err=NULL;

 cprintf("mindo  %d",menu[0]);

 switch(menu[0])
 {
  case FILE_M_MAIN:
         err=filedecode(menu+1,window);
         break;

  case WORK_M_MAIN:
         err=workdecode(menu+1,window);
         break;

  case CONF_M_MAIN:
         err=configdecode(menu+1,window);
         break;

  case HELP_M_MAIN:
         err=helpdecode(menu+1,window);
         break;
 
 }

 return(err);
}











int main(int argc,char * argv[])
{ 
 os_error * err;
 int        quit;

 setlocale(LC_ALL,".1252");

 err=inittask("SyncDiscs","SyncDiscs","!SyncDiscs",
                                      NULL,NULL,NULL);
 if(err)
 {
  report(err);
  exit(0);
 }

 cprintf("main point2");

#ifdef __DEBUG
 debugenable(NULL); 
#endif

// if(!err) err=seticonbar("!SyncDiscs");

 cprintf("point2a");

 if(!err) err=resinit("<SyncDiscsRes$Dir>");

 if(err) cprintf("point 2b");


 if(!err) err=addmessages();

 if(!err) err=menulostart("<SyncDiscsRes$Dir>","Menus");

  if(err) cprintf("point 2c");


 if(!err) err=scrapinit("SyncDiscs",NULL);

 if(!err) err=arcsinit();

 if(!err) err=configinit();

 if(err) cprintf("point 2d");

 if(!err) err=zoneinit();

// if(!err) err=getdirinit();
 if(!err) err=osshellinit(0);

 event(EVENT_RUNPROGRAM,NULL,0);

 if(err)
 {
  report(err);
  terminate();
  return(1);
 }

 if(argc>1)
 {
  report(commandline(argc,argv,&quit));
  if(quit)
  {
   terminate();
   return(0);
		}
 }

 err=opensyncdiscs();
 if(err)
 {
  report(err);
  terminate();
  return(1);
 }

 runtask();

 return(0);
}


